var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = build;

var _esperanto = require('esperanto');

var _esperanto2 = _interopRequireWildcard(_esperanto);

var _fs = require('fs');

var _fs2 = _interopRequireWildcard(_fs);

var _path = require('path');

var _path2 = _interopRequireWildcard(_path);

var _includes$template = require('lodash');

var tplPath = _path2['default'].join(__dirname, '../templates/import-build.tpl');
var buildTemplate = _includes$template.template(_fs2['default'].readFileSync(tplPath));

function build(methods, modules, options) {
  // Otherwise compile a file for them to the modularization
  var config = methods.map(function (name) {
    for (var category in modules) {
      if (_includes$template.includes(modules[category], name)) {
        break;
      }
    }
    return {
      name: name,
      path: _path2['default'].join(options.lodashPath, category, name)
    };
  });

  var code = buildTemplate({ config: config });
  var opts = {
    _evilES3SafeReExports: true,
    strict: false,
    name: options.global || '_'
  };
  switch (options.exports) {
    case 'cjs':
      return _esperanto2['default'].toCjs(code, opts);
    case 'amd':
      return _esperanto2['default'].toAmd(code, opts);
    case 'umd':
      return _esperanto2['default'].toUmd(code, opts);
    case 'es6':
      return { code: code };
  }
  throw 'Unsupported format: ' + options.exports;
}

module.exports = exports['default'];